/**
 * Copyright (c) 2011, Everit Kft.
 *
 * All rights reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301  USA
 */
(function( $ ) {
	
	var methods = {
			init : function( options ) {
				  
				  var settings = $.extend ({
					  'excludeInputList'	:	'',
					  'excludeConfirmList'	:	'',
					  'confirmQuestion'		:	'',
					  'formChanged'			:	false
				  }, options);
				  
				  
				  return this.each(function() {
					  var $this = $(this),
			          data = $this.data('formChecker');
					  
					  if ( ! data ) {
						data = {
								'formChanged' : settings['formChanged'],
								'confirmQuestion' : settings['confirmQuestion']
						};
						$this.data('formChecker', data);
						var excludeInputList = settings['excludeInputList'];
						var parentForm = $this.parents('form:first').get(0);
						var inputs = parentForm.getElementsByTagName('input');

						for (var j in inputs) {
						   var inputId=inputs[j].id;	   
						   if (inputId!=null){
							   if (!contains(excludeInputList, inputId)) {
							  	   $(jqEscapeAndAddHashmark(inputId)).change(function() {
							  			data['formChanged'] = true;
							  		});
							   }
					     	}
						} 

						var excludeConfirmList = settings['excludeConfirmList'];
						
						var localUnbindWindow = function () {
							$this.formChecker('unbindWindow');
						};
						
						var localReturnMessage = function () {
							return $this.formChecker('returnMessage');
						};

						for ( var j in excludeConfirmList) {
							document.getElementById(excludeConfirmList[j]).onclick = localUnbindWindow;
						}
						window.onbeforeunload = localReturnMessage;
					  }
				  });	  
			  },
		    reset : function() {
		    	var data = this.data('formChecker');
		    	data['formChanged'] = false;
		    },
		    formChanged : function() {
		    	var data = this.data('formChecker');
		    	data['formChanged'] = true;
		    },
		    returnMessage : function() {
		    	var data = this.data('formChecker');
			    var changed = data['formChanged'];
				var confirmQuestion = data['confirmQuestion'];					
				if (changed) {
					return confirmQuestion;
				} else {
					return null;
				}
		    },
		    unbindWindow : function unbindWindow() {
				window.onbeforeunload = null;
				return true;
			},
			destroy : function( ) {

			       return this.each(function(){
			         $(window).unbind('.formChecker');
			       });

			     }
			
	};
  
	$.fn.formChecker = function( method ) {
	    
	    if ( methods[method] ) {
	      return methods[method].apply( this, Array.prototype.slice.call( arguments, 1 ));
	    } else if ( typeof method === 'object' || ! method ) {
	      return methods.init.apply( this, arguments );
	    } else {
	      $.error( 'Method ' +  method + ' does not exist on jQuery.formChecker' );
	    }    
	  
	  };
  
})( jQuery );